Package org.eclipse.nebula.widgets.grid

## Class GridItem

- java.lang.Object
- - org.eclipse.swt.widgets.Widget
  - - org.eclipse.swt.widgets.Item
    - - org.eclipse.nebula.widgets.grid.GridItem

All Implemented Interfaces:
  `Adaptable`

    public class GridItem
    extends Item

Instances of this class represent a selectable user interface object that represents an item in a grid.

Styles:
  (none)
Events:
  (none)

### Constructor Summary

Constructors
`GridItem​(GridItem parent, int style)` Creates a new instance of this class as a child node of the given GridItem and places the item at the end of the parents items.
`GridItem​(GridItem parent, int style, int index)` Creates a new instance of this class as a child node of the given Grid and places the item at the given index in the parent items list.
`GridItem​(Grid parent, int style)` Creates a new instance of this class and places the item at the end of the grid.
`GridItem​(Grid parent, int style, int index)` Creates a new instance of this class and places the item in the grid at the given index.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `dispose()` Disposes of the operating system resources associated with the receiver and all its descendents.
`void` `fireCheckEvent​(int column)` Fires the appropriate events in response to a user checking/unchecking an item.
`void` `fireEvent​(int eventId)` Fires the given event type on the parent Grid instance.
`<T> T` `getAdapter​(java.lang.Class<T> adapter)` Implementation of the `Adaptable` interface.
`Color` `getBackground()` Returns the receiver's background color.
`Color` `getBackground​(int index)` Returns the background color at the given column index in the receiver.
`Rectangle` `getBounds​(int columnIndex)` Returns a rectangle describing the receiver's size and location relative to its parent at a column in the table.
`protected Point` `getCellSize​(int index)`
`boolean` `getCheckable​(int index)` Returns the checkable state at the given column index in the receiver.
`boolean` `getChecked()` Returns the checked state at the first column in the receiver.
`boolean` `getChecked​(int index)` Returns the checked state at the given column index in the receiver.
`int` `getColumnSpan​(int index)` Returns the column span for the given column index in the receiver.
`Font` `getFont()` Returns the font that the receiver will use to paint textual information for this item.
`Font` `getFont​(int index)` Returns the font that the receiver will use to paint textual information for the specified cell in this item.
`Color` `getForeground()` Returns the foreground color that the receiver will use to draw.
`Color` `getForeground​(int index)` Returns the foreground color at the given column index in the receiver.
`boolean` `getGrayed()` Returns `true` if the first column in the receiver is grayed, and false otherwise.
`boolean` `getGrayed​(int index)` Returns `true` if the column at the given index in the receiver is grayed, and false otherwise.
`Color` `getHeaderBackground()` Returns the receiver's row header background color
`Font` `getHeaderFont()` Returns the receiver's row header font
`Color` `getHeaderForeground()` Returns the receiver's row header foreground color
`Image` `getHeaderImage()` Returns the receiver's row header image.
`java.lang.String` `getHeaderText()` Returns the receiver's row header text.
`int` `getHeight()` Returns the height of this `GridItem`.
`Image` `getImage()` Returns the receiver's image if it has one, or null if it does not.
`Image` `getImage​(int index)` Returns the image stored at the given column index in the receiver, or null if the image has not been set or if the column does not exist.
`GridItem` `getItem​(int index)` Returns the item at the given, zero-relative index in the receiver.
`int` `getItemCount()` Returns the number of items contained in the receiver that are direct item children of the receiver.
`GridItem[]` `getItems()` Returns a (possibly empty) array of `GridItem`s which are the direct item children of the receiver.
`int` `getLevel()` Returns the level of this item in the tree.
`Grid` `getParent()` Returns the receiver's parent, which must be a `Grid`.
`GridItem` `getParentItem()` Returns the receiver's parent item, which must be a `GridItem` or null when the receiver is a root.
`java.lang.String` `getText()` Returns the receiver's text, which will be an empty string if it has never been set.
`java.lang.String` `getText​(int index)` Returns the text stored at the given column index in the receiver, or empty string if the text has not been set.
`java.lang.String` `getToolTipText​(int index)` Returns the tooltip for the given cell.
`boolean` `hasChildren()` Returns true if this item has children.
`int` `indexOf​(GridItem item)` Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item.
`boolean` `isExpanded()` Returns `true` if the receiver is expanded, and false otherwise.
`boolean` `isVisible()`
`void` `pack()` Sets this `GridItem` to its preferred height.
`void` `setBackground​(int index, Color background)` Sets the background color at the given column index in the receiver to the color specified by the argument, or to the default system color for the item if the argument is null.
`void` `setBackground​(Color background)` Sets the receiver's background color to the color specified by the argument, or to the default system color for the item if the argument is null.
`void` `setCheckable​(int index, boolean checked)` Sets the checkable state at the given column index in the receiver.
`void` `setChecked​(boolean checked)` Sets the checked state at the first column in the receiver.
`void` `setChecked​(int index, boolean checked)` Sets the checked state at the given column index in the receiver.
`void` `setColumnSpan​(int index, int span)` Sets the column spanning for the column at the given index to span the given number of subsequent columns.
`void` `setExpanded​(boolean expanded)` Sets the expanded state of the receiver.
`void` `setFont​(int index, Font font)` Sets the font that the receiver will use to paint textual information for the specified cell in this item to the font specified by the argument, or to the default font for that kind of control if the argument is null.
`void` `setFont​(Font font)` Sets the font that the receiver will use to paint textual information for this item to the font specified by the argument, or to the default font for that kind of control if the argument is null.
`void` `setForeground​(int index, Color foreground)` Sets the foreground color at the given column index in the receiver to the color specified by the argument, or to the default system color for the item if the argument is null.
`void` `setForeground​(Color foreground)` Sets the receiver's foreground color to the color specified by the argument, or to the default system color for the item if the argument is null.
`void` `setGrayed​(boolean grayed)` Sets the grayed state of the checkbox for the first column.
`void` `setGrayed​(int index, boolean grayed)` Sets the grayed state of the checkbox for the given column index.
`void` `setHeaderBackground​(Color headerBackground)` Set the new header background
`void` `setHeaderFont​(Font headerFont)` Set the new header font
`void` `setHeaderForeground​(Color headerForeground)` Set the new header foreground
`void` `setHeaderImage​(Image image)` Sets the receiver's row header image.
`void` `setHeaderText​(java.lang.String text)` Sets the receiver's row header text.
`void` `setHeight​(int height)` Sets the height of this `GridItem`.
`void` `setImage​(int index, Image image)` Sets the receiver's image at a column.
`void` `setImage​(Image image)` Sets the receiver's image to the argument, which may be null indicating that no image should be displayed.
`void` `setText​(int index, java.lang.String text)` Sets the receiver's text at a column.
`void` `setText​(java.lang.String string)` Sets the receiver's text.
`void` `setToolTipText​(int index, java.lang.String tooltip)` Sets the tooltip for the given column index.

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, checkSubclass, checkWidget, getData, getData, getDisplay, getListeners, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, reskin, setData, setData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### GridItem

    public GridItem​(Grid parent,
                    int style)

Creates a new instance of this class and places the item at the end of the grid.

Parameters:
  `parent` - parent grid
  `style` - item style
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass

#### GridItem

    public GridItem​(Grid parent,
                    int style,
                    int index)

Creates a new instance of this class and places the item in the grid at the given index.

Parameters:
  `parent` - parent grid
  `style` - item style
  `index` - index where to insert item
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass

#### GridItem

    public GridItem​(GridItem parent,
                    int style)

Creates a new instance of this class as a child node of the given GridItem and places the item at the end of the parents items.

Parameters:
  `parent` - parent item
  `style` - item style
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass

#### GridItem

    public GridItem​(GridItem parent,
                    int style,
                    int index)

Creates a new instance of this class as a child node of the given Grid and places the item at the given index in the parent items list.

Parameters:
  `parent` - parent item
  `style` - item style
  `index` - index to place item
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass

### Method Detail

#### dispose

    public void dispose()

Disposes of the operating system resources associated with the receiver and all its descendents. After this method has been invoked, the receiver and all descendents will answer `true` when sent the message `isDisposed()`. Any internal connections between the widgets in the tree will have been removed to facilitate garbage collection.

NOTE: This method is not called recursively on the descendents of the receiver. This means that, widget implementers can not detect when a widget is being disposed of by re-implementing this method, but should instead listen for the `Dispose` event.

Overrides:
  `dispose` in class `Widget`
See Also:
  `Widget.addDisposeListener(org.eclipse.swt.events.DisposeListener)`, `Widget.removeDisposeListener(org.eclipse.swt.events.DisposeListener)`, `Widget.checkWidget()`

#### fireEvent

    public void fireEvent​(int eventId)

Fires the given event type on the parent Grid instance. This method should only be called from within a cell renderer. Any other use is not intended.

Parameters:
  `eventId` - SWT event constant
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### fireCheckEvent

    public void fireCheckEvent​(int column)

Fires the appropriate events in response to a user checking/unchecking an item. Checking an item fires both a selection event (with event.detail of SWT.CHECK) if the checkbox is in the first column and the seperate check listener (all columns). This method manages that behavior. This method should only be called from within a cell renderer. Any other use is not intended.

Parameters:
  `column` - the column where the checkbox resides
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getParent

    public Grid getParent()

Returns the receiver's parent, which must be a `Grid`.

Returns:
  the receiver's parent
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getParentItem

    public GridItem getParentItem()

Returns the receiver's parent item, which must be a `GridItem` or null when the receiver is a root.

Returns:
  the receiver's parent item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItemCount

    public int getItemCount()

Returns the number of items contained in the receiver that are direct item children of the receiver.

Returns:
  the number of items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItems

    public GridItem[] getItems()

Returns a (possibly empty) array of `GridItem`s which are the direct item children of the receiver.

Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

Returns:
  the receiver's items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItem

    public GridItem getItem​(int index)

Returns the item at the given, zero-relative index in the receiver. Throws an exception if the index is out of range.

Parameters:
  `index` - the index of the item to return
Returns:
  the item at the given index
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### indexOf

    public int indexOf​(GridItem item)

Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item. If no item is found, returns -1.

Parameters:
  `item` - the search item
Returns:
  the index of the item
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the item is null
  - ERROR_INVALID_ARGUMENT - if the item has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### hasChildren

    public boolean hasChildren()

Returns true if this item has children.

Returns:
  true if this item has children
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### isExpanded

    public boolean isExpanded()

Returns `true` if the receiver is expanded, and false otherwise.

Returns:
  the expanded state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setExpanded

    public void setExpanded​(boolean expanded)

Sets the expanded state of the receiver.

Parameters:
  `expanded` - the new expanded state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getLevel

    public int getLevel()

Returns the level of this item in the tree.

Returns:
  the level of the item in the tree
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setFont

    public void setFont​(Font font)

Sets the font that the receiver will use to paint textual information for this item to the font specified by the argument, or to the default font for that kind of control if the argument is null.

Parameters:
  `font` - the new font (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getFont

    public Font getFont()

Returns the font that the receiver will use to paint textual information for this item.

Returns:
  the receiver's font
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setFont

    public void setFont​(int index,
                        Font font)

Sets the font that the receiver will use to paint textual information for the specified cell in this item to the font specified by the argument, or to the default font for that kind of control if the argument is null.

Parameters:
  `index` - the column index
  `font` - the new font (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getFont

    public Font getFont​(int index)

Returns the font that the receiver will use to paint textual information for the specified cell in this item.

Parameters:
  `index` - the column index
Returns:
  the receiver's font
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setBackground

    public void setBackground​(Color background)

Sets the receiver's background color to the color specified by the argument, or to the default system color for the item if the argument is null.

Parameters:
  `background` - the new color (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getBackground

    public Color getBackground()

Returns the receiver's background color.

Returns:
  the background color
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setBackground

    public void setBackground​(int index,
                              Color background)

Sets the background color at the given column index in the receiver to the color specified by the argument, or to the default system color for the item if the argument is null.

Parameters:
  `index` - the column index
  `background` - the new color (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getBackground

    public Color getBackground​(int index)

Returns the background color at the given column index in the receiver.

Parameters:
  `index` - the column index
Returns:
  the background color
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setForeground

    public void setForeground​(Color foreground)

Sets the receiver's foreground color to the color specified by the argument, or to the default system color for the item if the argument is null.

Parameters:
  `foreground` - the new color (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getForeground

    public Color getForeground()

Returns the foreground color that the receiver will use to draw.

Returns:
  the receiver's foreground color
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setForeground

    public void setForeground​(int index,
                              Color foreground)

Sets the foreground color at the given column index in the receiver to the color specified by the argument, or to the default system color for the item if the argument is null.

Parameters:
  `index` - the column index
  `foreground` - the new color (or null)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getForeground

    public Color getForeground​(int index)

Returns the foreground color at the given column index in the receiver.

Parameters:
  `index` - the column index
Returns:
  the foreground color
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setText

    public void setText​(java.lang.String string)

Sets the receiver's text.

Overrides:
  `setText` in class `Item`
Parameters:
  `string` - the new text

#### getText

    public java.lang.String getText()

Returns the receiver's text, which will be an empty string if it has never been set.

Overrides:
  `getText` in class `Item`
Returns:
  the receiver's text

#### setText

    public void setText​(int index,
                        java.lang.String text)

Sets the receiver's text at a column.

Parameters:
  `index` - the column index
  `text` - the new text
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the text is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getText

    public java.lang.String getText​(int index)

Returns the text stored at the given column index in the receiver, or empty string if the text has not been set.

Parameters:
  `index` - the column index
Returns:
  the text stored at the given column index in the receiver
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setToolTipText

    public void setToolTipText​(int index,
                               java.lang.String tooltip)

Sets the tooltip for the given column index.

Parameters:
  `index` - the column index
  `tooltip` - the tooltip text
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getToolTipText

    public java.lang.String getToolTipText​(int index)

Returns the tooltip for the given cell.

Parameters:
  `index` - the column index
Returns:
  the tooltip
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setImage

    public void setImage​(Image image)

Sets the receiver's image to the argument, which may be null indicating that no image should be displayed.

Overrides:
  `setImage` in class `Item`
Parameters:
  `image` - the image to display on the receiver (may be null)

#### getImage

    public Image getImage()

Returns the receiver's image if it has one, or null if it does not.

Overrides:
  `getImage` in class `Item`
Returns:
  the receiver's image

#### setImage

    public void setImage​(int index,
                         Image image)

Sets the receiver's image at a column.

Parameters:
  `index` - the column index
  `image` - the new image
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the image has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getImage

    public Image getImage​(int index)

Returns the image stored at the given column index in the receiver, or null if the image has not been set or if the column does not exist.

Parameters:
  `index` - the column index
Returns:
  the image stored at the given column index in the receiver
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setChecked

    public void setChecked​(boolean checked)

Sets the checked state at the first column in the receiver.

Parameters:
  `checked` - the new checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getChecked

    public boolean getChecked()

Returns the checked state at the first column in the receiver.

Returns:
  the checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setChecked

    public void setChecked​(int index,
                           boolean checked)

Sets the checked state at the given column index in the receiver.

Parameters:
  `index` - the column index
  `checked` - the new checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getChecked

    public boolean getChecked​(int index)

Returns the checked state at the given column index in the receiver.

Parameters:
  `index` - the column index
Returns:
  the checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setGrayed

    public void setGrayed​(boolean grayed)

Sets the grayed state of the checkbox for the first column. This state change only applies if the GridColumn was created with the SWT.CHECK style.

Parameters:
  `grayed` - the new grayed state of the checkbox;
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getGrayed

    public boolean getGrayed()

Returns `true` if the first column in the receiver is grayed, and false otherwise. When the GridColumn does not have the `CHECK` style, return false.

Returns:
  the grayed state of the checkbox
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setGrayed

    public void setGrayed​(int index,
                          boolean grayed)

Sets the grayed state of the checkbox for the given column index. This state change only applies if the GridColumn was created with the SWT.CHECK style.

Parameters:
  `index` - the column index
  `grayed` - the new grayed state of the checkbox;
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getGrayed

    public boolean getGrayed​(int index)

Returns `true` if the column at the given index in the receiver is grayed, and false otherwise. When the GridColumn does not have the `CHECK` style, return false.

Parameters:
  `index` - the column index
Returns:
  the grayed state of the checkbox
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setCheckable

    public void setCheckable​(int index,
                             boolean checked)

Sets the checkable state at the given column index in the receiver. A checkbox which is uncheckable will not be modifiable by the user but still make be modified programmatically. If the column at the given index is not checkable then individual cell will not be checkable regardless.

Parameters:
  `index` - the column index
  `checked` - the new checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getCheckable

    public boolean getCheckable​(int index)

Returns the checkable state at the given column index in the receiver. If the column at the given index is not checkable then this will return false regardless of the individual cell's checkable state.

Parameters:
  `index` - the column index
Returns:
  the checked state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setColumnSpan

    public void setColumnSpan​(int index,
                              int span)

Sets the column spanning for the column at the given index to span the given number of subsequent columns.

Parameters:
  `index` - column index that should span
  `span` - number of subsequent columns to span
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1

#### getColumnSpan

    public int getColumnSpan​(int index)

Returns the column span for the given column index in the receiver.

Parameters:
  `index` - the column index
Returns:
  the number of columns spanned (0 equals no columns spanned)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1

#### setHeight

    public void setHeight​(int height)

Sets the height of this `GridItem`.

Parameters:
  `height` - new height in pixels
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getHeight

    public int getHeight()

Returns the height of this `GridItem`.

Returns:
  height of this `GridItem`

#### setHeaderText

    public void setHeaderText​(java.lang.String text)

Sets the receiver's row header text. If the text is `null` the row header will display the row number.

Parameters:
  `text` - the new text
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the text is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### getHeaderText

    public java.lang.String getHeaderText()

Returns the receiver's row header text. If the text is `null` the row header will display the row number.

Returns:
  the text stored for the row header or code `null` if the default has to be displayed
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### setHeaderImage

    public void setHeaderImage​(Image image)

Sets the receiver's row header image. If the image is `null` none is shown in the header

Parameters:
  `image` - the new image
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### getHeaderImage

    public Image getHeaderImage()

Returns the receiver's row header image.

Returns:
  the image stored for the header or `null` if none has to be displayed
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### setHeaderBackground

    public void setHeaderBackground​(Color headerBackground)

Set the new header background

Parameters:
  `headerBackground` - the color or `null`
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### getHeaderBackground

    public Color getHeaderBackground()

Returns the receiver's row header background color

Returns:
  the color or `null` if none
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### setHeaderForeground

    public void setHeaderForeground​(Color headerForeground)

Set the new header foreground

Parameters:
  `headerForeground` - the color or `null`
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### getHeaderForeground

    public Color getHeaderForeground()

Returns the receiver's row header foreground color

Returns:
  the color or `null` if none
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### setHeaderFont

    public void setHeaderFont​(Font headerFont)

Set the new header font

Parameters:
  `headerFont` - the font or `null`
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### getHeaderFont

    public Font getHeaderFont()

Returns the receiver's row header font

Returns:
  the font or `null` if none
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.14

#### pack

    public void pack()

Sets this `GridItem` to its preferred height.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getBounds

    public Rectangle getBounds​(int columnIndex)

Returns a rectangle describing the receiver's size and location relative to its parent at a column in the table.

Parameters:
  `columnIndex` - the index that specifies the column
Returns:
  the receiver's bounding column rectangle
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getAdapter

    public <T> T getAdapter​(java.lang.Class<T> adapter)

Description copied from class: `Widget`
Implementation of the `Adaptable` interface.

IMPORTANT: This method is not part of the RWT public API. It is marked public only so that it can be shared within the packages provided by RWT. It should never be accessed from application code.

Specified by:
  `getAdapter` in interface `Adaptable`
Overrides:
  `getAdapter` in class `Widget`
Parameters:
  `adapter` - the lookup class
Returns:
  an object that can be cast to the given class or `null` if there is no adapter associated with the given class.

#### isVisible

    public boolean isVisible()

#### getCellSize

    protected Point getCellSize​(int index)